<id>
din1031:savepmashtml
</id>

<version>
1.0.7
</version>

<edit file>
$boarddir/index.php
</edit file>

<search for>
		'pm' => array('PersonalMessage.php', 'MessageMain'),
</search for>

<add after>
		'pmsave' => array('PersonalMessage.php', 'Message_Save_as_HTML'),
		'pmsaveall' => array('PersonalMessage.php', 'Messages_save_all'),
</add after>

<edit file>
$sourcedir/ManageSettings.php
</edit file>

<search for>
			array('check', 'enableReportPM'),
</search for>

<add after>
			array('check', 'SaveAllPMsEnabled'),
</add after>

<edit file>
$sourcedir/PersonalMessage.php
</edit file>

<search for>
	// Handle labels.
	if (empty($context['currently_using_labels']))
		unset($context['pm_areas']['labels']);
</search for>

<add before>
	//Pah i need to add this only if it enabled ;)
	if(!empty($modSettings['SaveAllPMsEnabled'])) {
		$context['pm_areas']['folders']['areas'][] = array();
		$context['pm_areas']['folders']['areas']['saveall'] = array('link' => '<a href="' . $scripturl . '?action=pmsaveall'.($context['folder'] == 'sent' ? ';sa=pm_out' : '') .'">' . $txt['SaveAllPMs'] . '</a>', 'href' => $scripturl . '?action=pmsaveall'.($context['folder'] == 'sent' ? ';sa=pm_out' : ''));
	}

</add before>

<search for>
	if (isset($_REQUEST['del_selected']))
		$_REQUEST['pm_action'] = 'delete';
</search for>

<replace>
	if (isset($_REQUEST['del_selected']))
		$_REQUEST['pm_action'] = 'delete';
	
	// Multiple PM Saving =)
	if (isset($_REQUEST['save_selected']))
	{
		// Assume Inbox or Outbox
		$_REQUEST['sa'] = !isset($_REQUEST['f']) || $_REQUEST['f'] == 'inbox' ? 'pm_in' : 'pm_out';
		return Message_Save_as_HTML($_REQUEST['pms']);
	}
</replace>

<search for>
?>
</search for>

<add before>
function Message_Save_as_HTML($pid = null) {
	global $db_prefix, $txt, $scripturl, $context;
	global $board_info, $user_info;
	global $modSettings, $smcFunc; 
	
	// No guests!
	is_not_guest();
	// You're not supposed to be here at all, if you can't even read PMs.
	isAllowedTo('pm_read');

	//Check the pid for multi read (save_all give all pid in one array! 
	if (empty($pid)) {
		if (is_numeric($_REQUEST['pid']) && $_REQUEST['pid'] > 0)
			$pid = array($_REQUEST['pid']);
		else
			redirectexit('action=pm');
	}
	elseif(!is_array($pid))
		$pid = array($pid);
	else
		$pid = array_unique($pid);

	if (!isset($_REQUEST['sa']) || $_REQUEST['sa'] == 'pm_in') {
		$add_search = "pmr.deleted = 0 AND pmr.id_member = ".$user_info['id'];
		//I would like only to know who did sent me the messages not more!
		$sent_to_all = '';
	}
	elseif($_REQUEST['sa'] == 'pm_out') {
		//Oh i need only the my own and not delted pms *nice*
		$add_search = "pm.deleted_by_sender = 0 AND pm.id_member_from = ".$user_info['id'];
		//Only my own sent pms are allowed to see all informations like bcc etc etc...
		$sent_to_all = ', pmr.bcc as bcc'; 
	}
	else
		redirectexit('action=pm');
	
	$context['PM_with_images'] = false;
	$context['pm'] = array();
	$owners = array();
	
	//Load the pms... IN array ;)
	$request = $smcFunc['db_query']('', "
		SELECT 	pm.id_pm as id_pm, pm.id_member_from as id_member_from, pm.from_name as from_name, 
					pm.msgtime as time, pm.subject as subject, pm.body as pmtext,
					pmr.id_member as sentto $sent_to_all
		FROM {$db_prefix}personal_messages as pm
			LEFT JOIN {$db_prefix}pm_recipients as pmr ON (pm.id_pm = pmr.id_pm)
		WHERE pm.id_pm ".(count($pid) == 1 ? "= '".current($pid)."'": "IN ('".implode("', '",$pid)."')")." AND ".
		$add_search
	);
	
	while ($row = $smcFunc['db_fetch_assoc']($request)) {
	
		if(!isset($context['pm'][$row['id_pm']])) {
			$context['pm'][$row['id_pm']] = array(
				'ID' => $row['id_pm'],
				'ID_MEMBER_FROM' => array(
					'id' => $row['id_member_from'],
					'name' => $row['from_name'],
				),
				'sentto' => array (
					'to' => array(),
					'bcc' => array(),
				),
				'subject' => $row['subject'],
				'pmtext' => parse_bbc($row['pmtext'], false),
				'time' => timeformat($row['time'], false),
			);
		}
		//Huhhh which people become the pm... or only a sent to me =)
		if(!empty($sent_to_all))
			$item = ($row['bcc'] == 1 ? 'bcc' : 'to');
		else
			$item = 'to';
			
		$context['pm'][$row['id_pm']]['sentto'][$item][$row['sentto']] = array(
			'id' => $row['sentto'],
			'name' => $txt['guest'],
		);
		
		//Collect the member id i need to load them later *g*
		$owners[$row['sentto']] = $row['sentto'];
		$owners[$row['id_member_from']] = $row['id_member_from'];

		if(!$context['PM_with_images'])
			$context['PM_with_images'] = preg_match('~(\[img.*?\])(.+?)\[/img\]~eis', $row['pmtext']) !== 0;
	}	

	$smcFunc['db_free_result']($request);

	//No pms loaded... tsts people try everything...	
	if(empty($context['pm']))
		redirectexit('action=pm');
		
	//So Let's load some memberdatas...
	if (!empty($owners)) {
		//Now i can Load the Missing global :)
		global $user_profile;

		loadMemberData($owners);

		//So let's replace the links...
		foreach($context['pm'] as $PM_ID => $PM_array) {
			if(!empty($context['pm'][$PM_ID]['id_member_from']['id'])) {
				$profile = $user_profile[$context['pm'][$PM_ID]['id_member_from']['id']];
				$context['pm'][$PM_ID]['ID_MEMBER_FROM']['name'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
			}
			if(!empty($context['pm'][$PM_ID]['sentto']['to'])) {
				foreach($context['pm'][$PM_ID]['sentto']['to'] as $k => $v) {
					if(!empty($v['id'])) {
						$profile = $user_profile[$v['id']];
						if (!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
							$context['pm'][$PM_ID]['sentto']['to'][$k]['name'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
						else
							$context['pm'][$PM_ID]['sentto']['to'][$k]['name'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '">' . $profile['real_name'] . '</a>';
					}
				}
			}
			if(!empty($context['pm'][$PM_ID]['sentto']['bcc'])) {
				foreach($context['pm'][$PM_ID]['sentto']['bcc'] as $k => $v)	{
					if(!empty($v['id'])) {
						$profile = $user_profile[$v['id']];
						if (!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
							$context['pm'][$PM_ID]['sentto']['bcc'][$k]['name'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['real_name'] . '</span></a>';
						else
							$context['pm'][$PM_ID]['sentto']['bcc'][$k]['name'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['id_member'] . '" title="' . $txt['profile_of'] . ' ' . $profile['real_name'] . '">' . $profile['real_name'] . '</a>';
					}
				}
			}
		}
	}
	
	loadTemplate('IMSave');
		
	$context['template_layers'] = array('IMSave');
	$context['topic_subject'] = $txt['personal_messages']." - ".(count($pid) == 1 ? '#'.current($pid) : timeformat(time(), false));
	$context['file_name'] = (count($pid) == 1 ? 'PM'.current($pid) : time()).'.html';

	//Make the template version compatible...
	$txt[196] = $txt['subject'];
	$txt[176] = $txt['on'];
}

//Load all Messages... (Currently no limit... but i thing about it).
function Messages_save_all() {
	global $db_prefix, $txt, $scripturl, $context;
	global $board_info, $user_info;
	global $modSettings, $smcFunc; 
	
	if(empty($modSettings['SaveAllPMsEnabled']))
		fatal_error($txt['SaveAllPMsEnabled_error'], false);

	// No guests!
	is_not_guest();
	// You're not supposed to be here at all, if you can't even read PMs.
	isAllowedTo('pm_read');

	if (!isset($_REQUEST['sa']) || $_REQUEST['sa'] == 'pm_in') {
		$add_search = "pmr.deleted = 0 AND pmr.id_member = $user_info[id]" ;
	}
	elseif($_REQUEST['sa'] == 'pm_out') {
		//Oh i need only the my own and not delted pms *nice*
		$add_search = "pm.deleted_by_sender = 0 AND pm.id_member_from = $user_info[id]";
	}
	else
		redirectexit('action=pm');

	$pms = array();
	
	//Load the pms... IN array ;)
	$request = $smcFunc['db_query']('', "
		SELECT 	pm.id_pm as id_pm
		FROM {$db_prefix}personal_messages as pm
			LEFT JOIN {$db_prefix}pm_recipients as pmr ON (pm.id_pm = pmr.id_pm)
		WHERE $add_search");
	
	while ($row = $smcFunc['db_fetch_assoc']($request)) 
		$pms[] = $row['id_pm'];

	$smcFunc['db_free_result']($request);
		
	//TsTs no pms... gna i hate people who try this...
	if(empty($pms))
		redirectexit('action=pm');
	
	//Remove the double pms...
	$pms = array_unique($pms);
	
	//if(count($pms) > 250)
	//	fatal_error('Bitte nicht mehr als 250 PMs gleichzeitig speichern!', false);
	
	Message_Save_as_HTML($pms);
}
</add before>

<edit file>
$themedir/PersonalMessage.template.php
</edit file>

<search for>
		$delete_button = create_button('delete.gif', 'remove_message', 'remove', 'align="middle"');
</search for>

<add after>
		$savepm_button = create_button('savepm_b.gif', 'SavePM', 'SavePM', 'align="middle"');
</add after>

<search for>
			echo '
										<a href="', $scripturl, '?action=pm;sa=pmactions;pm_actions[', $message['id'], ']=delete;f=', $context['folder'], ';start=', $context['start'], $context['current_label_id'] != -1 ? ';l=' . $context['current_label_id'] : '', ';', $context['session_var'], '=', $context['session_id'], '" onclick="return confirm(\'', addslashes($txt['remove_message']), '?\');">', $delete_button, '</a>';
</search for>

<add before>
			echo '
										<a href="', $scripturl, '?action=pmsave', ($context['folder'] != 'sent' ? '' : ';sa=pm_out'), ';pid=', $message['id'], '">', $savepm_button, '</a>';
</add before>

<search for>
		echo '
				<input type="submit" name="del_selected" value="', $txt['quickmod_delete_selected'], '" style="font-weight: normal;" onclick="if (!confirm(\'', $txt['delete_selected_confirm'], '\')) return false;" />';
</search for>

<replace>
		echo '
				<input type="submit" name="save_selected" value="', $txt['SavePM'], '" style="font-weight: normal;" />';
		echo '
				<input type="submit" name="del_selected" value="', $txt['quickmod_delete_selected'], '" style="font-weight: normal;" onclick="if (!confirm(\'', $txt['delete_selected_confirm'], '\')) return false;" />';
</replace>

<search for>
					<div style="float: right;"><input type="submit" name="del_selected" value="', $txt['quickmod_delete_selected'], '" style="font-weight: normal;" onclick="if (!confirm(\'', $txt['delete_selected_confirm'], '\')) return false;" /></div>
</search for>

<replace>
					<div style="float: right;"><input type="submit" name="del_selected" value="', $txt['quickmod_delete_selected'], '" style="font-weight: normal;" onclick="if (!confirm(\'', $txt['delete_selected_confirm'], '\')) return false;" /></div>
					<div style="float: right;"><input type="submit" name="save_selected" value="', $txt['SavePM'], '" style="font-weight: normal;" /></div>
</replace>